//---------------------------------------------------------------------------
#ifndef App_ListDialogH
#define App_ListDialogH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
//---------------------------------------------------------------------------
class TAppListDialog : public TForm
{
__published:
	TButton* Button1;
	TButton* Button2;
	TLabel* Label1;
	TListBox* ListBox1;
	void __fastcall ListBox1Click(TObject* ASender);
private:
	void __fastcall UpdateAccess();
	void __fastcall UpdateScrollWidth();
	AnsiString __fastcall GetMessage();
	void __fastcall SetMessage(const AnsiString& AMessage);
	TStrings* __fastcall GetItems();
	int __fastcall GetItemIndex();
	void __fastcall SetItemIndex(int AItemIndex);
	bool __fastcall GetSelected(int AIndex);
	void __fastcall SetSelected(int AIndex, bool ASelected);
	int __fastcall GetSelectionCount();
	bool __fastcall GetMultiSelect();
	void __fastcall SetMultiSelect(bool AMultiSelect);
protected:
public:
	__fastcall TAppListDialog(TComponent* AOwner);
	virtual __fastcall ~TAppListDialog();
	static TAppListDialog* __fastcall EnsureCreate();
	virtual bool __fastcall Execute();
	virtual void __fastcall SelectAll();
	virtual void __fastcall ClearSelection();
	__property AnsiString Message = {read=GetMessage, write=SetMessage};
	__property TStrings* Items = {read=GetItems};
	__property int ItemIndex = {read=GetItemIndex, write=SetItemIndex};
	__property bool Selected[int AIndex] = {read=GetSelected, write=SetSelected};
	__property int SelectionCount = {read=GetSelectionCount};
	__property bool MultiSelect = {read=GetMultiSelect, write=SetMultiSelect};
};
//---------------------------------------------------------------------------
extern PACKAGE TAppListDialog* AppListDialog;
//---------------------------------------------------------------------------
#endif

