//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include <Comctrls.hpp>
#include <Forms.hpp>
#include <IniFiles.hpp>
#include "App_View.h"
#include "Moa_Forms.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
namespace App_view {
//---------------------------------------------------------------------------
bool __fastcall TViewModel::GetShowToolbar()
{
	return Toolbar->Visible;
}
//---------------------------------------------------------------------------
void __fastcall TViewModel::SetShowToolbar(bool AShowToolbar)
{
	Toolbar->Visible = AShowToolbar;
}
//---------------------------------------------------------------------------
bool __fastcall TViewModel::GetShowStatusBar()
{
	return StatusBar->Visible;
}
//---------------------------------------------------------------------------
void __fastcall TViewModel::SetShowStatusBar(bool AShowStatusBar)
{
	StatusBar->Visible = AShowStatusBar;
}
//---------------------------------------------------------------------------
__fastcall TViewModel::TViewModel(TForm* AForm, TListView* AListView, TToolBar* AToolbar, TStatusBar* AStatusBar) :
	TModel(),
	FForm(AForm),
	FListView(AListView),
	FToolbar(AToolbar),
	FStatusBar(AStatusBar)
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TViewModel::~TViewModel()
{
	// Do nothing
}
//---------------------------------------------------------------------------
void __fastcall TViewModel::LoadSettings(TMemIniFile* ASettings, const AnsiString& ASection)
{
	AnsiString LSection = ASection + ".Form";
	{
		TRect LBounds = TFormUtilities::GetNormalBounds(Form);
		LBounds.left = ASettings->ReadInteger(
			LSection,
			"left",
			LBounds.left);
		LBounds.top = ASettings->ReadInteger(
			LSection,
			"top",
			LBounds.top);
		LBounds.right = ASettings->ReadInteger(
			LSection,
			"right",
			LBounds.right);
		LBounds.bottom = ASettings->ReadInteger(
			LSection,
			"bottom",
			LBounds.bottom);
		TFormUtilities::SetNormalBounds(Form, LBounds);
	}
	for(int LI = 0; LI < ListView->Columns->Count; ++LI) {
		LSection = ASection + AnsiString().sprintf(".ListView.Columns.Items[%d]", LI);
		ListView->Columns->Items[LI]->Width = ASettings->ReadInteger(
			LSection,
			"Width",
			ListView->Columns->Items[LI]->Width);
	}
	LSection = ASection + ".Toolbar";
	{
		Toolbar->Visible = ASettings->ReadBool(
			LSection,
			"Visible",
			Toolbar->Visible);
	}
	LSection = ASection + ".StatusBar";
	{
		StatusBar->Visible = ASettings->ReadBool(
			LSection,
			"Visible",
			StatusBar->Visible);
	}
}
//---------------------------------------------------------------------------
void __fastcall TViewModel::SaveSettings(TMemIniFile* ASettings, const AnsiString& ASection)
{
	AnsiString LSection = ASection + ".Form";
	{
		TRect LBounds = TFormUtilities::GetNormalBounds(Form);
		ASettings->WriteInteger(
			LSection,
			"left",
			LBounds.left);
		ASettings->WriteInteger(
			LSection,
			"top",
			LBounds.top);
		ASettings->WriteInteger(
			LSection,
			"right",
			LBounds.right);
		ASettings->WriteInteger(
			LSection,
			"bottom",
			LBounds.bottom);
	}
	for(int LI = 0; LI < ListView->Columns->Count; ++LI) {
		LSection = ASection + AnsiString().sprintf(".ListView.Columns.Items[%d]", LI);
		ASettings->WriteInteger(
			LSection,
			"Width",
			ListView->Columns->Items[LI]->Width);
	}
	LSection = ASection + ".Toolbar";
	{
		ASettings->WriteBool(
			LSection,
			"Visible",
			Toolbar->Visible);
	}
	LSection = ASection + ".StatusBar";
	{
		ASettings->WriteBool(
			LSection,
			"Visible",
			StatusBar->Visible);
	}
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
__fastcall TViewCommands::TViewCommands(TViewModel* AViewModel) :
	TCommands(),
	FViewModel(AViewModel)
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TViewCommands::~TViewCommands()
{
	// Do nothing
}
//---------------------------------------------------------------------------
void __fastcall TViewCommands::ToggleShowToolbar()
{
	if(!CanToggleShowToolbar()) {
		HandleFeatureUnavailable();
	}
	ViewModel->ShowToolbar = !ViewModel->ShowToolbar;
}
//---------------------------------------------------------------------------
bool __fastcall TViewCommands::CanToggleShowToolbar()
{
	return true;
}
//---------------------------------------------------------------------------
void __fastcall TViewCommands::ToggleShowStatusBar()
{
	if(!CanToggleShowStatusBar()) {
		HandleFeatureUnavailable();
	}
	ViewModel->ShowStatusBar = !ViewModel->ShowStatusBar;
}
//---------------------------------------------------------------------------
bool __fastcall TViewCommands::CanToggleShowStatusBar()
{
	return true;
}
//---------------------------------------------------------------------------
} // End namespace App_view
//---------------------------------------------------------------------------

