//---------------------------------------------------------------------------
#ifndef App_ViewH
#define App_ViewH
//---------------------------------------------------------------------------
#include "App_Common.h"
namespace Comctrls {class TListView;} using namespace Comctrls;
namespace Comctrls {class TStatusBar;} using namespace Comctrls;
namespace Comctrls {class TToolBar;} using namespace Comctrls;
namespace Forms {class TForm;} using namespace Forms;
//---------------------------------------------------------------------------
namespace App_view {
//---------------------------------------------------------------------------
class TViewModel : public TModel
{
private:
	TForm* FForm;
	TListView* FListView;
	TToolBar* FToolbar;
	TStatusBar* FStatusBar;
	bool __fastcall GetShowToolbar();
	void __fastcall SetShowToolbar(bool AShowToolbar);
	bool __fastcall GetShowStatusBar();
	void __fastcall SetShowStatusBar(bool AShowStatusBar);
	__property TForm* Form = {read=FForm};
	__property TListView* ListView = {read=FListView};
	__property TToolBar* Toolbar = {read=FToolbar};
	__property TStatusBar* StatusBar = {read=FStatusBar};
protected:
public:
	__fastcall TViewModel(TForm* AForm, TListView* AListView, TToolBar* AToolbar, TStatusBar* AStatusBar);
	virtual __fastcall ~TViewModel();
	virtual void __fastcall LoadSettings(TMemIniFile* ASettings, const AnsiString& ASection);
	virtual void __fastcall SaveSettings(TMemIniFile* ASettings, const AnsiString& ASection);
	__property bool ShowToolbar = {read=GetShowToolbar, write=SetShowToolbar};
	__property bool ShowStatusBar = {read=GetShowStatusBar, write=SetShowStatusBar};
};
//---------------------------------------------------------------------------
class TViewCommands : public TCommands
{
private:
	TViewModel* FViewModel;
	__property TViewModel* ViewModel = {read=FViewModel};
protected:
public:
	__fastcall TViewCommands(TViewModel* AViewModel);
	virtual __fastcall ~TViewCommands();
	virtual void __fastcall ToggleShowToolbar();
	virtual bool __fastcall CanToggleShowToolbar();
	virtual void __fastcall ToggleShowStatusBar();
	virtual bool __fastcall CanToggleShowStatusBar();
};
//---------------------------------------------------------------------------
} // End namespace App_view
using namespace App_view;
//---------------------------------------------------------------------------
#endif

